/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.MarcaDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("marcaService")
public class MarcaServiceImpl implements MarcaService {

    @Autowired
    private MarcaDAO marcaDAO;

    public List<Marca> obtenerTodos() {
        return marcaDAO.obtenerTodos();
    }

    public Marca obtenerID(Short id) {
        return marcaDAO.obtenerID(id);
    }

    @Transactional
    public Marca suscribir(Marca entidad) {
    	
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaDAO.suscribir(entidad);
    }

    @Transactional
    public Marca actualizacion(Marca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Marca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        marcaDAO.actualizacion(entidad);
    }

    public List<Marca> buscarPorNome(String nomeMarca) {
        return marcaDAO.buscarPorNome(nomeMarca);
    }

    public List<Marca> buscarTodosExceto(Usuario usuario,Integer... idMarca) {
        return marcaDAO.buscarTodosExceto(usuario,idMarca);
    }

	@Override
	public List<Marca> buscarDescricaoIdMarca() {
		return marcaDAO.buscarDescricaoIdMarca();
	}
	

	public List<Marca> buscarMarcaPorEmpresa(List<Empresa> empresa){
		return marcaDAO.buscarMarcaPorEmpresa(empresa);
	}
}
